<?php

namespace DigiComp\HetznerDnsApi\Model;

class PrimaryServerResponse
{
    /**
     * Port number of the primary server
     *
     * @var int|null
     */
    protected $port;
    /**
     * ID of primary server
     *
     * @var string|null
     */
    protected $id;
    /**
     * Time primary server was created
     *
     * @var \DateTime|null
     */
    protected $created;
    /**
     * Time primary server was last updated
     *
     * @var \DateTime|null
     */
    protected $modified;
    /**
     * ID of zone this record is associated with
     *
     * @var string|null
     */
    protected $zoneId;
    /**
     * IPv4 or IPv6 address of the primary server
     *
     * @var string|null
     */
    protected $address;
    /**
     * Port number of the primary server
     *
     * @return int|null
     */
    public function getPort() : ?int
    {
        return $this->port;
    }
    /**
     * Port number of the primary server
     *
     * @param int|null $port
     *
     * @return self
     */
    public function setPort(?int $port) : self
    {
        $this->port = $port;
        return $this;
    }
    /**
     * ID of primary server
     *
     * @return string|null
     */
    public function getId() : ?string
    {
        return $this->id;
    }
    /**
     * ID of primary server
     *
     * @param string|null $id
     *
     * @return self
     */
    public function setId(?string $id) : self
    {
        $this->id = $id;
        return $this;
    }
    /**
     * Time primary server was created
     *
     * @return \DateTime|null
     */
    public function getCreated() : ?\DateTime
    {
        return $this->created;
    }
    /**
     * Time primary server was created
     *
     * @param \DateTime|null $created
     *
     * @return self
     */
    public function setCreated(?\DateTime $created) : self
    {
        $this->created = $created;
        return $this;
    }
    /**
     * Time primary server was last updated
     *
     * @return \DateTime|null
     */
    public function getModified() : ?\DateTime
    {
        return $this->modified;
    }
    /**
     * Time primary server was last updated
     *
     * @param \DateTime|null $modified
     *
     * @return self
     */
    public function setModified(?\DateTime $modified) : self
    {
        $this->modified = $modified;
        return $this;
    }
    /**
     * ID of zone this record is associated with
     *
     * @return string|null
     */
    public function getZoneId() : ?string
    {
        return $this->zoneId;
    }
    /**
     * ID of zone this record is associated with
     *
     * @param string|null $zoneId
     *
     * @return self
     */
    public function setZoneId(?string $zoneId) : self
    {
        $this->zoneId = $zoneId;
        return $this;
    }
    /**
     * IPv4 or IPv6 address of the primary server
     *
     * @return string|null
     */
    public function getAddress() : ?string
    {
        return $this->address;
    }
    /**
     * IPv4 or IPv6 address of the primary server
     *
     * @param string|null $address
     *
     * @return self
     */
    public function setAddress(?string $address) : self
    {
        $this->address = $address;
        return $this;
    }
}